> ## Documentation Index
> Fetch the complete documentation index at: https://docs.mastermindcms.com/llms.txt
> Use this file to discover all available pages before exploring further.

# CustomerServiceImpl

> Aufruf öffentlicher Servicemethoden über die REST API: customerServiceImpl

<ResponseField name="beanId" type="string">
  Die Spring-Bean-ID des aufzurufenden Services.

  customerServiceImpl
</ResponseField>

<ResponseField name="scope" type="string" default="PROTOTYPE">
  Bean-Scope. Für Serviceaufrufe wird PROTOTYPE verwendet.
</ResponseField>

<ResponseField name="functionName" type="string">
  Der öffentliche Methodenname des Services, der in der Signatur angegeben ist.
</ResponseField>

<ResponseField name="args" type="object[]">
  Das Argument-Array der Methode. Jedes Argument wird mit dem Index 0, 1 usw. übergeben; der Wert muss dem Java-Parametertyp entsprechen.
</ResponseField>

## Headers

```http theme={null}
POST /api/v1/bean/request
Content-Type: application/json
Lang-Context: de
Site-Context: my-site
Authorization: Bearer <token>
```

Senden Sie `Lang-Context` und `Site-Context` mit jeder Anfrage. Für geschützte Methoden senden Sie das JWT im Header `Authorization` im Format `Bearer <token>`.

**Zugriff:** GUEST. **Bearer Token:** nicht erforderlich.

* GUEST — nicht angemeldete Benutzer; nur Whitelist-Services sind verfügbar.
* USER — Authentifizierung erforderlich; Methoden mit USER-Prüfung sind verfügbar.
* ADMIN — vollständiger Zugriff auf öffentliche Methoden aller Services.
* Wenn eine Methode intern eine Rolle prüft, kann GUEST null erhalten.

## Methoden

<ResponseField name="getRepository" type="SellerRepository">
  | Argument | Typ | Beschreibung                              |
  | -------- | --- | ----------------------------------------- |
  | —        | —   | Diese Methode akzeptiert keine Argumente. |

  ### getRepository

  ```json theme={null}
  {
    "beanId": "customerServiceImpl",
    "scope": "PROTOTYPE",
    "functionName": "getRepository",
    "args": []
  }
  ```
</ResponseField>

<ResponseField name="getPaginationCustomers" type="Deque<Map<String, Object>>">
  | Argument      | Typ      | Beschreibung                |
  | ------------- | -------- | --------------------------- |
  | `requestJson` | `String` | Übergeben über `args[0].0`. |

  ### getPaginationCustomers

  ```json theme={null}
  {
    "beanId": "customerServiceImpl",
    "scope": "PROTOTYPE",
    "functionName": "getPaginationCustomers",
    "args": [
      {
        "0": null
      }
    ]
  }
  ```
</ResponseField>

<ResponseField name="validateVerificationToken" type="boolean">
  | Argument            | Typ      | Beschreibung                |
  | ------------------- | -------- | --------------------------- |
  | `verificationToken` | `String` | Übergeben über `args[0].0`. |

  ### validateVerificationToken

  ```json theme={null}
  {
    "beanId": "customerServiceImpl",
    "scope": "PROTOTYPE",
    "functionName": "validateVerificationToken",
    "args": [
      {
        "0": null
      }
    ]
  }
  ```
</ResponseField>

<ResponseField name="validatePasswordResetToken" type="boolean">
  | Argument             | Typ      | Beschreibung                |
  | -------------------- | -------- | --------------------------- |
  | `passwordResetToken` | `String` | Übergeben über `args[0].0`. |

  ### validatePasswordResetToken

  ```json theme={null}
  {
    "beanId": "customerServiceImpl",
    "scope": "PROTOTYPE",
    "functionName": "validatePasswordResetToken",
    "args": [
      {
        "0": null
      }
    ]
  }
  ```
</ResponseField>

<ResponseField name="sendVerificationEmail" type="void">
  | Argument    | Typ                             | Beschreibung                |
  | ----------- | ------------------------------- | --------------------------- |
  | `userAsMap` | `LinkedHashMap<String, Object>` | Übergeben über `args[0].0`. |

  ### sendVerificationEmail

  Beispiel für das JSON-Anfrageobjekt:

  ```json theme={null}
  {
      "id":  null,
      "username":  null,
      "password":  null,
      "savedPassword":  null,
      "fallIntoObjects":  null,
      "active":  false,
      "roles":  null,
      "permissions":  null
  }
  ```

  Request:

  ```json theme={null}
  {
    "beanId": "customerServiceImpl",
    "scope": "PROTOTYPE",
    "functionName": "sendVerificationEmail",
    "args": [
      {
        "0": null
      }
    ]
  }
  ```
</ResponseField>

<ResponseField name="searchCustomers" type="SearchResponse">
  | Argument       | Typ                             | Beschreibung                |
  | -------------- | ------------------------------- | --------------------------- |
  | `requestAsMap` | `LinkedHashMap<String, Object>` | Übergeben über `args[0].0`. |

  ### searchCustomers

  Beispiel für das JSON-Anfrageobjekt:

  ```json theme={null}
  {
      "type":  "SellerSKU",
      "searchTerm":  "",
      "query":  {
                    "isPublishedForSale":  true
                },
      "ignoreRegexWrap":  [
                              "id",
                              "name",
                              "embeddedSku",
                              "productsRef",
                              "isPublishedForSale"
                          ],
      "offset":  0,
      "limit":  10,
      "visiblePages":  10,
      "page":  1,
      "sortName":  "createdDate",
      "sortDirection":  "DESC"
  }
  ```

  Request:

  ```json theme={null}
  {
    "beanId": "customerServiceImpl",
    "scope": "PROTOTYPE",
    "functionName": "searchCustomers",
    "args": [
      {
        "0": null
      }
    ]
  }
  ```
</ResponseField>

<ResponseField name="searchCustomersLightweight" type="SearchResponse">
  | Argument       | Typ                             | Beschreibung                |
  | -------------- | ------------------------------- | --------------------------- |
  | `requestAsMap` | `LinkedHashMap<String, Object>` | Übergeben über `args[0].0`. |

  ### searchCustomersLightweight

  Beispiel für das JSON-Anfrageobjekt:

  ```json theme={null}
  {
      "type":  "SellerSKU",
      "searchTerm":  "",
      "query":  {
                    "isPublishedForSale":  true
                },
      "ignoreRegexWrap":  [
                              "id",
                              "name",
                              "embeddedSku",
                              "productsRef",
                              "isPublishedForSale"
                          ],
      "offset":  0,
      "limit":  10,
      "visiblePages":  10,
      "page":  1,
      "sortName":  "createdDate",
      "sortDirection":  "DESC"
  }
  ```

  Request:

  ```json theme={null}
  {
    "beanId": "customerServiceImpl",
    "scope": "PROTOTYPE",
    "functionName": "searchCustomersLightweight",
    "args": [
      {
        "0": null
      }
    ]
  }
  ```
</ResponseField>

<ResponseField name="getCustomersPaged" type="Page<Seller>">
  | Argument      | Typ      | Beschreibung                |
  | ------------- | -------- | --------------------------- |
  | `requestJson` | `String` | Übergeben über `args[0].0`. |

  ### getCustomersPaged

  ```json theme={null}
  {
    "beanId": "customerServiceImpl",
    "scope": "PROTOTYPE",
    "functionName": "getCustomersPaged",
    "args": [
      {
        "0": null
      }
    ]
  }
  ```
</ResponseField>

<ResponseField name="registerCustomerFull" type="Seller">
  | Argument        | Typ                             | Beschreibung                |
  | --------------- | ------------------------------- | --------------------------- |
  | `customerAsMap` | `LinkedHashMap<String, Object>` | Übergeben über `args[0].0`. |

  ### registerCustomerFull

  Beispiel für das JSON-Anfrageobjekt:

  ```json theme={null}
  {
      "id":  null,
      "stripeCustomerId":  null,
      "stripeConnectId":  null,
      "address":  null,
      "shippingAddresses":  null,
      "companyName":  null,
      "vatNumber":  null,
      "numberOfEmployees":  null,
      "sellerType":  null,
      "sellerTariff":  null,
      "subscription":  null,
      "companyEmailAddress":  null,
      "companyPhone":  null,
      "companyWebSite":  null,
      "imageURLs":  null,
      "documentURLs":  null,
      "description":  null,
      "profiles":  null,
      "certificates":  null,
      "sellerSKUs":  null,
      "ordersBuyer":  null,
      "ordersVendor":  null,
      "favoriteSellersIds":  null,
      "favoriteSellerSkuIds":  null,
      "sellerCategoriesIds":  null,
      "sellerProductsIds":  null,
      "emailNotifications":  false,
      "onlineActive":  false
  }
  ```

  Request:

  ```json theme={null}
  {
    "beanId": "customerServiceImpl",
    "scope": "PROTOTYPE",
    "functionName": "registerCustomerFull",
    "args": [
      {
        "0": null
      }
    ]
  }
  ```
</ResponseField>

<ResponseField name="searchEmployees" type="LinkedHashSet<Profile>">
  | Argument      | Typ      | Beschreibung                |
  | ------------- | -------- | --------------------------- |
  | `requestJson` | `String` | Übergeben über `args[0].0`. |

  ### searchEmployees

  ```json theme={null}
  {
    "beanId": "customerServiceImpl",
    "scope": "PROTOTYPE",
    "functionName": "searchEmployees",
    "args": [
      {
        "0": null
      }
    ]
  }
  ```
</ResponseField>

<ResponseField name="searchEmployeesPaged" type="Page<Profile>">
  | Argument      | Typ      | Beschreibung                |
  | ------------- | -------- | --------------------------- |
  | `requestJson` | `String` | Übergeben über `args[0].0`. |

  ### searchEmployeesPaged

  ```json theme={null}
  {
    "beanId": "customerServiceImpl",
    "scope": "PROTOTYPE",
    "functionName": "searchEmployeesPaged",
    "args": [
      {
        "0": null
      }
    ]
  }
  ```
</ResponseField>

<ResponseField name="registerCustomerSimplified" type="Profile">
  | Argument           | Typ                             | Beschreibung                |
  | ------------------ | ------------------------------- | --------------------------- |
  | `userProfileAsMap` | `LinkedHashMap<String, Object>` | Übergeben über `args[0].0`. |

  ### registerCustomerSimplified

  Beispiel für das JSON-Anfrageobjekt:

  ```json theme={null}
  {
      "id":  null,
      "user":  null,
      "firstName":  null,
      "lastName":  null,
      "website":  null,
      "phone":  null,
      "mobilePhone":  null,
      "birthday":  null,
      "emailAddress":  null,
      "gender":  null,
      "salutation":  null,
      "embeddedParent":  null,
      "emailNotifications":  false,
      "imageURLs":  null
  }
  ```

  Request:

  ```json theme={null}
  {
    "beanId": "customerServiceImpl",
    "scope": "PROTOTYPE",
    "functionName": "registerCustomerSimplified",
    "args": [
      {
        "0": null
      }
    ]
  }
  ```
</ResponseField>

<ResponseField name="updateCustomer" type="Seller">
  | Argument      | Typ                             | Beschreibung                |
  | ------------- | ------------------------------- | --------------------------- |
  | `sellerAsMap` | `LinkedHashMap<String, Object>` | Übergeben über `args[0].0`. |

  ### updateCustomer

  Beispiel für das JSON-Anfrageobjekt:

  ```json theme={null}
  {
      "id":  null,
      "stripeCustomerId":  null,
      "stripeConnectId":  null,
      "address":  null,
      "companyName":  null,
      "vatNumber":  null,
      "numberOfEmployees":  null,
      "sellerType":  null,
      "sellerTariff":  null,
      "subscription":  null,
      "companyEmailAddress":  null,
      "companyPhone":  null,
      "companyWebSite":  null,
      "description":  null,
      "imageURLs":  null,
      "shippingAddresses":  null,
      "documentURLs":  null,
      "profileIds":  null,
      "certificateIds":  null,
      "sellerSkuIds":  null,
      "ordersAsBuyerIds":  null,
      "ordersAsVendorIds":  null,
      "favoriteSellersIds":  null,
      "favoriteSellerSkuIds":  null,
      "sellerCategoriesIds":  null,
      "sellerProductsIds":  null,
      "emailNotifications":  false,
      "onlineActive":  false,
      "imageUrlRemove":  false,
      "metaInfo":  null,
      "createdBy":  null,
      "createdDate":  null,
      "lastModifiedBy":  null,
      "lastModifiedDate":  null,
      "alias":  null
  }
  ```

  Request:

  ```json theme={null}
  {
    "beanId": "customerServiceImpl",
    "scope": "PROTOTYPE",
    "functionName": "updateCustomer",
    "args": [
      {
        "0": null
      }
    ]
  }
  ```
</ResponseField>

<ResponseField name="updateCustomerProfile" type="Profile">
  | Argument           | Typ                             | Beschreibung                |
  | ------------------ | ------------------------------- | --------------------------- |
  | `userProfileAsMap` | `LinkedHashMap<String, Object>` | Übergeben über `args[0].0`. |

  ### updateCustomerProfile

  Beispiel für das JSON-Anfrageobjekt:

  ```json theme={null}
  {
      "id":  null,
      "user":  null,
      "firstName":  null,
      "lastName":  null,
      "website":  null,
      "phone":  null,
      "mobilePhone":  null,
      "birthday":  null,
      "emailAddress":  null,
      "gender":  null,
      "salutation":  null,
      "embeddedParent":  null,
      "emailNotifications":  false,
      "imageURLs":  null
  }
  ```

  Request:

  ```json theme={null}
  {
    "beanId": "customerServiceImpl",
    "scope": "PROTOTYPE",
    "functionName": "updateCustomerProfile",
    "args": [
      {
        "0": null
      }
    ]
  }
  ```
</ResponseField>

<ResponseField name="mapSellerToDto" type="SellerDTO">
  | Argument        | Typ                             | Beschreibung                |
  | --------------- | ------------------------------- | --------------------------- |
  | `customerAsMap` | `LinkedHashMap<String, Object>` | Übergeben über `args[0].0`. |

  ### mapSellerToDto

  Beispiel für das JSON-Anfrageobjekt:

  ```json theme={null}
  {
      "id":  null,
      "stripeCustomerId":  null,
      "stripeConnectId":  null,
      "address":  null,
      "shippingAddresses":  null,
      "companyName":  null,
      "vatNumber":  null,
      "numberOfEmployees":  null,
      "sellerType":  null,
      "sellerTariff":  null,
      "subscription":  null,
      "companyEmailAddress":  null,
      "companyPhone":  null,
      "companyWebSite":  null,
      "imageURLs":  null,
      "documentURLs":  null,
      "description":  null,
      "profiles":  null,
      "certificates":  null,
      "sellerSKUs":  null,
      "ordersBuyer":  null,
      "ordersVendor":  null,
      "favoriteSellersIds":  null,
      "favoriteSellerSkuIds":  null,
      "sellerCategoriesIds":  null,
      "sellerProductsIds":  null,
      "emailNotifications":  false,
      "onlineActive":  false
  }
  ```

  Request:

  ```json theme={null}
  {
    "beanId": "customerServiceImpl",
    "scope": "PROTOTYPE",
    "functionName": "mapSellerToDto",
    "args": [
      {
        "0": null
      }
    ]
  }
  ```
</ResponseField>
